/***************************************************************************
 *   Copyright (C) 2005 by Yuri Vatis   																								*
 *   vatis@tnt.uni-hannover.de																														*
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

//#include <iostream.h>
#include <math.h>
//#include <fstream.h>
#include <QPainter>
#include <QPaintDevice>
#include <QColor>
#include <QCloseEvent>
#include <QPushButton>
#include <QImage>

#include "mainwindow.h"
#include "display.h"



#define wgtab(w)        { \
(int) (-128.0*w-0.5),(int) (-127.0*w-0.5),(int) (-126.0*w-0.5),(int) (-125.0*w-0.5),    \
(int) (-124.0*w-0.5),(int) (-123.0*w-0.5),(int) (-122.0*w-0.5),(int) (-121.0*w-0.5),    \
(int) (-120.0*w-0.5),(int) (-119.0*w-0.5),(int) (-118.0*w-0.5),(int) (-117.0*w-0.5),    \
(int) (-116.0*w-0.5),(int) (-115.0*w-0.5),(int) (-114.0*w-0.5),(int) (-113.0*w-0.5),    \
(int) (-112.0*w-0.5),(int) (-111.0*w-0.5),(int) (-110.0*w-0.5),(int) (-109.0*w-0.5),    \
(int) (-108.0*w-0.5),(int) (-107.0*w-0.5),(int) (-106.0*w-0.5),(int) (-105.0*w-0.5),    \
(int) (-104.0*w-0.5),(int) (-103.0*w-0.5),(int) (-102.0*w-0.5),(int) (-101.0*w-0.5),    \
(int) (-100.0*w-0.5),(int) ( -99.0*w-0.5),(int) ( -98.0*w-0.5),(int) ( -97.0*w-0.5),    \
(int) ( -96.0*w-0.5),(int) ( -95.0*w-0.5),(int) ( -94.0*w-0.5),(int) ( -93.0*w-0.5),    \
(int) ( -92.0*w-0.5),(int) ( -91.0*w-0.5),(int) ( -90.0*w-0.5),(int) ( -89.0*w-0.5),    \
(int) ( -88.0*w-0.5),(int) ( -87.0*w-0.5),(int) ( -86.0*w-0.5),(int) ( -85.0*w-0.5),    \
(int) ( -84.0*w-0.5),(int) ( -83.0*w-0.5),(int) ( -82.0*w-0.5),(int) ( -81.0*w-0.5),    \
(int) ( -80.0*w-0.5),(int) ( -79.0*w-0.5),(int) ( -78.0*w-0.5),(int) ( -77.0*w-0.5),    \
(int) ( -76.0*w-0.5),(int) ( -75.0*w-0.5),(int) ( -74.0*w-0.5),(int) ( -73.0*w-0.5),    \
(int) ( -72.0*w-0.5),(int) ( -71.0*w-0.5),(int) ( -70.0*w-0.5),(int) ( -69.0*w-0.5),    \
(int) ( -68.0*w-0.5),(int) ( -67.0*w-0.5),(int) ( -66.0*w-0.5),(int) ( -65.0*w-0.5),    \
(int) ( -64.0*w-0.5),(int) ( -63.0*w-0.5),(int) ( -62.0*w-0.5),(int) ( -61.0*w-0.5),    \
(int) ( -60.0*w-0.5),(int) ( -59.0*w-0.5),(int) ( -58.0*w-0.5),(int) ( -57.0*w-0.5),    \
(int) ( -56.0*w-0.5),(int) ( -55.0*w-0.5),(int) ( -54.0*w-0.5),(int) ( -53.0*w-0.5),    \
(int) ( -52.0*w-0.5),(int) ( -51.0*w-0.5),(int) ( -50.0*w-0.5),(int) ( -49.0*w-0.5),    \
(int) ( -48.0*w-0.5),(int) ( -47.0*w-0.5),(int) ( -46.0*w-0.5),(int) ( -45.0*w-0.5),    \
(int) ( -44.0*w-0.5),(int) ( -43.0*w-0.5),(int) ( -42.0*w-0.5),(int) ( -41.0*w-0.5),    \
(int) ( -40.0*w-0.5),(int) ( -39.0*w-0.5),(int) ( -38.0*w-0.5),(int) ( -37.0*w-0.5),    \
(int) ( -36.0*w-0.5),(int) ( -35.0*w-0.5),(int) ( -34.0*w-0.5),(int) ( -33.0*w-0.5),    \
(int) ( -32.0*w-0.5),(int) ( -31.0*w-0.5),(int) ( -30.0*w-0.5),(int) ( -29.0*w-0.5),    \
(int) ( -28.0*w-0.5),(int) ( -27.0*w-0.5),(int) ( -26.0*w-0.5),(int) ( -25.0*w-0.5),    \
(int) ( -24.0*w-0.5),(int) ( -23.0*w-0.5),(int) ( -22.0*w-0.5),(int) ( -21.0*w-0.5),    \
(int) ( -20.0*w-0.5),(int) ( -19.0*w-0.5),(int) ( -18.0*w-0.5),(int) ( -17.0*w-0.5),    \
(int) ( -16.0*w-0.5),(int) ( -15.0*w-0.5),(int) ( -14.0*w-0.5),(int) ( -13.0*w-0.5),    \
(int) ( -12.0*w-0.5),(int) ( -11.0*w-0.5),(int) ( -10.0*w-0.5),(int) (  -9.0*w-0.5),    \
(int) (  -8.0*w-0.5),(int) (  -7.0*w-0.5),(int) (  -6.0*w-0.5),(int) (  -5.0*w-0.5),    \
(int) (  -4.0*w-0.5),(int) (  -3.0*w-0.5),(int) (  -2.0*w-0.5),(int) (  -1.0*w-0.5),    \
(int) (   0.0*w+0.5),(int) (   1.0*w+0.5),(int) (   2.0*w+0.5),(int) (   3.0*w+0.5),    \
(int) (   4.0*w+0.5),(int) (   5.0*w+0.5),(int) (   6.0*w+0.5),(int) (   7.0*w+0.5),    \
(int) (   8.0*w+0.5),(int) (   9.0*w+0.5),(int) (  10.0*w+0.5),(int) (  11.0*w+0.5),    \
(int) (  12.0*w+0.5),(int) (  13.0*w+0.5),(int) (  14.0*w+0.5),(int) (  15.0*w+0.5),    \
(int) (  16.0*w+0.5),(int) (  17.0*w+0.5),(int) (  18.0*w+0.5),(int) (  19.0*w+0.5),    \
(int) (  20.0*w+0.5),(int) (  21.0*w+0.5),(int) (  22.0*w+0.5),(int) (  23.0*w+0.5),    \
(int) (  24.0*w+0.5),(int) (  25.0*w+0.5),(int) (  26.0*w+0.5),(int) (  27.0*w+0.5),    \
(int) (  28.0*w+0.5),(int) (  29.0*w+0.5),(int) (  30.0*w+0.5),(int) (  31.0*w+0.5),    \
(int) (  32.0*w+0.5),(int) (  33.0*w+0.5),(int) (  34.0*w+0.5),(int) (  35.0*w+0.5),    \
(int) (  36.0*w+0.5),(int) (  37.0*w+0.5),(int) (  38.0*w+0.5),(int) (  39.0*w+0.5),    \
(int) (  40.0*w+0.5),(int) (  41.0*w+0.5),(int) (  42.0*w+0.5),(int) (  43.0*w+0.5),    \
(int) (  44.0*w+0.5),(int) (  45.0*w+0.5),(int) (  46.0*w+0.5),(int) (  47.0*w+0.5),    \
(int) (  48.0*w+0.5),(int) (  49.0*w+0.5),(int) (  50.0*w+0.5),(int) (  51.0*w+0.5),    \
(int) (  52.0*w+0.5),(int) (  53.0*w+0.5),(int) (  54.0*w+0.5),(int) (  55.0*w+0.5),    \
(int) (  56.0*w+0.5),(int) (  57.0*w+0.5),(int) (  58.0*w+0.5),(int) (  59.0*w+0.5),    \
(int) (  60.0*w+0.5),(int) (  61.0*w+0.5),(int) (  62.0*w+0.5),(int) (  63.0*w+0.5),    \
(int) (  64.0*w+0.5),(int) (  65.0*w+0.5),(int) (  66.0*w+0.5),(int) (  67.0*w+0.5),    \
(int) (  68.0*w+0.5),(int) (  69.0*w+0.5),(int) (  70.0*w+0.5),(int) (  71.0*w+0.5),    \
(int) (  72.0*w+0.5),(int) (  73.0*w+0.5),(int) (  74.0*w+0.5),(int) (  75.0*w+0.5),    \
(int) (  76.0*w+0.5),(int) (  77.0*w+0.5),(int) (  78.0*w+0.5),(int) (  79.0*w+0.5),    \
(int) (  80.0*w+0.5),(int) (  81.0*w+0.5),(int) (  82.0*w+0.5),(int) (  83.0*w+0.5),    \
(int) (  84.0*w+0.5),(int) (  85.0*w+0.5),(int) (  86.0*w+0.5),(int) (  87.0*w+0.5),    \
(int) (  88.0*w+0.5),(int) (  89.0*w+0.5),(int) (  90.0*w+0.5),(int) (  91.0*w+0.5),    \
(int) (  92.0*w+0.5),(int) (  93.0*w+0.5),(int) (  94.0*w+0.5),(int) (  95.0*w+0.5),    \
(int) (  96.0*w+0.5),(int) (  97.0*w+0.5),(int) (  98.0*w+0.5),(int) (  99.0*w+0.5),    \
(int) ( 100.0*w+0.5),(int) ( 101.0*w+0.5),(int) ( 102.0*w+0.5),(int) ( 103.0*w+0.5),    \
(int) ( 104.0*w+0.5),(int) ( 105.0*w+0.5),(int) ( 106.0*w+0.5),(int) ( 107.0*w+0.5),    \
(int) ( 108.0*w+0.5),(int) ( 109.0*w+0.5),(int) ( 110.0*w+0.5),(int) ( 111.0*w+0.5),    \
(int) ( 112.0*w+0.5),(int) ( 113.0*w+0.5),(int) ( 114.0*w+0.5),(int) ( 115.0*w+0.5),    \
(int) ( 116.0*w+0.5),(int) ( 117.0*w+0.5),(int) ( 118.0*w+0.5),(int) ( 119.0*w+0.5),    \
(int) ( 120.0*w+0.5),(int) ( 121.0*w+0.5),(int) ( 122.0*w+0.5),(int) ( 123.0*w+0.5),    \
(int) ( 124.0*w+0.5),(int) ( 125.0*w+0.5),(int) ( 126.0*w+0.5),(int) ( 127.0*w+0.5)     }

static int ubtab[256] = wgtab( (0.587/0.331) );
static int vrtab[256] = wgtab( (0.419/0.299) );
static int ugtab[256] = wgtab( (0.114/0.331) );
static int vgtab[256] = wgtab( (0.299/0.419) );


static void yuv2rgb_400(uchar *rgb,uchar *y0,long width,long height)
{
	register uint *p0;
	register long m,n;
	register long b,g,r;
	register long iy;

	p0=(uint *) rgb;

	n=height;
	do
	{
		m=width;
		do
		{
			iy=(uint) y0[0];

			b=iy;

			if ( b<0 ) b=0;

			if ( b>255 ) b=255;
			r=g=b;

			p0[0]=b|(g<<8)|(r<<16);

			y0++;
			p0++;
		}
		while (--m);
	}
	while (--n);
}


static void yuv2rgb_420(uchar *rgb,uchar *y0,uchar *u,uchar *v,long width,long height)
{
	register uchar *y1;
	register uint *p0,*p1;
	register long m,n;
	register long b,g,r;
	register long iu,iv,iw,iy;

	p0=(uint *) rgb;
	p1=(uint *) (((ulong) p0)+4*width);
	y1=y0+width;

	n=height>>1;

	do
	{
		m=width>>1;
		do
		{
			iu=(uint) u[0];
			iv=(uint) v[0];

			iw=ugtab[iu]+vgtab[iv];
			iu=ubtab[iu];
			iv=vrtab[iv];

			iy=(uint) y0[0];

			b=iy+iu;
			g=iy-iw;
			r=iy+iv;

			if ( b<0 ) b=0;
			if ( g<0 ) g=0;
			if ( r<0 ) r=0;

			if ( b>255 ) b=255;
			if ( g>255 ) g=255;
			if ( r>255 ) r=255;

			p0[0]=b|(g<<8)|(r<<16);


			iy=(uint) y0[1];

			b=iy+iu;
			g=iy-iw;
			r=iy+iv;

			if ( b<0 ) b=0;
			if ( g<0 ) g=0;
			if ( r<0 ) r=0;

			if ( b>255 ) b=255;
			if ( g>255 ) g=255;
			if ( r>255 ) r=255;

			p0[1]=b|(g<<8)|(r<<16);

			y0+=2;
			p0+=2;


			iy=(uint) y1[0];

			b=iy+iu;
			g=iy-iw;
			r=iy+iv;

			if ( b<0 ) b=0;
			if ( g<0 ) g=0;
			if ( r<0 ) r=0;

			if ( b>255 ) b=255;
			if ( g>255 ) g=255;
			if ( r>255 ) r=255;

			p1[0]=b|(g<<8)|(r<<16);


			iy=(uint) y1[1];

			b=iy+iu;
			g=iy-iw;
			r=iy+iv;

			if ( b<0 ) b=0;
			if ( g<0 ) g=0;
			if ( r<0 ) r=0;

			if ( b>255 ) b=255;
			if ( g>255 ) g=255;
			if ( r>255 ) r=255;

			p1[1]=b|(g<<8)|(r<<16);


			y1+=2;
			p1+=2;

			u++;
			v++;
		}
		while (--m);

		p0=(uint *) (((ulong) p0)+4*width);
		p1=(uint *) (((ulong) p1)+4*width);

		y0+=width;
		y1+=width;
	}
	while (--n);
}

static void yuv2rgb_422(uchar *rgb,uchar *y0,uchar *u,uchar *v,long width,long height)
{
	register uint *p0;
	register long n;
	register long b,g,r;
	register long iu,iv,iw,iy;

	p0=(uint *) rgb;

	n=height*(width>>1);
  --u;
  --v;
  --y0;
  --p0;
	do
	{
		iu=(uint) *(++u);
		iv=(uint) *(++v);

		iw=ugtab[iu]+vgtab[iv];
		iu=ubtab[iu];
		iv=vrtab[iv];

		iy=(uint) *(++y0);

		b=iy+iu;
		g=iy-iw;
		r=iy+iv;

		if ( b<0 ) b=0;
		if ( g<0 ) g=0;
		if ( r<0 ) r=0;

		if ( b>255 ) b=255;
		if ( g>255 ) g=255;
		if ( r>255 ) r=255;

		*(++p0)=b|(g<<8)|(r<<16);

		iy=(uint) *(++y0);

		b=iy+iu;
		g=iy-iw;
		r=iy+iv;

		if ( b<0 ) b=0;
		if ( g<0 ) g=0;
		if ( r<0 ) r=0;

		if ( b>255 ) b=255;
		if ( g>255 ) g=255;
		if ( r>255 ) r=255;

		*(++p0)=b|(g<<8)|(r<<16);
	}
	while (--n);
}


static void yuv2rgb_444(uchar *rgb,uchar *y0,uchar *u,uchar *v,long width,long height)
{
	register uint *p0;
	register long m,n;
	register long b,g,r;
	register long iu,iv,iw,iy;

	p0=(uint *) rgb;

	n=height;

	do
	{
		m=width;
		do
		{
			iu=(uint) u[0];
			iv=(uint) v[0];

			iw=ugtab[iu]+vgtab[iv];
			iu=ubtab[iu];
			iv=vrtab[iv];

			iy=(uint) y0[0];

			b=iy+iu;
			g=iy-iw;
			r=iy+iv;

			if ( b<0 ) b=0;
			if ( g<0 ) g=0;
			if ( r<0 ) r=0;

			if ( b>255 ) b=255;
			if ( g>255 ) g=255;
			if ( r>255 ) r=255;

			p0[0]=b|(g<<8)|(r<<16);
			p0++;
			y0++;
			u++;
			v++;
		}
		while (--m);
	}
	while (--n);
}


Seqdis::Seqdis (QWidget *parent, Qt::WFlags flags) : QWidget(parent, flags)
{
	this->parent = (MainWindow*)(parent);
	sizeX = sizeY = 0;
	yuvbuf=0;
	cur_frame_nr = 0;
	total_frame_nr = 0;
	img=NULL;
	YBlock = new TableYValues(this, Qt::Window);
	if(flags != 0)
		par = 2;
	else
		par = 1;
}

Seqdis::~Seqdis()
{
	;
}

void Seqdis::setSize(int sx, int sy)
{
	this->sizeX = sx;
	this->sizeY = sy;
}

int Seqdis::getTotalFrameNr() const
{
	return this->total_frame_nr;
}

uchar* Seqdis::getYUVBuffer() const
{
	return yuvbuf;
}

int Seqdis::loadFile(QString fName, int sX, int sY, int yuv)
{
	qint64 length;
	sizeX = sX;
	sizeY = sY;
	format = yuv;
	if(fName != NULL)
	{
		if(file.isOpen())
			file.close();
		file.setFileName(fName);
		file.open(QIODevice::ReadOnly);
	}
	length = file.size();
	if(format == _420)
	{
		yuvbuffersize = sizeX*sizeY*3/2;
		total_frame_nr = 2*length/sizeX/sizeY/3;
	}
	else if(format == _400)
	{
		yuvbuffersize = sizeX*sizeY;
		total_frame_nr = length/sizeX/sizeY;
	}
	else if(format == _422)
	{
		yuvbuffersize = 2*sizeX*sizeY;
		total_frame_nr = length/sizeX/sizeY/2;
	}
	else // format = _444
	{
		yuvbuffersize = 3*sizeX*sizeY;
		total_frame_nr = length/sizeX/sizeY/3;
	}
	if (yuvbuf) {
		delete[] yuvbuf;
	}
	yuvbuf = new uchar[yuvbuffersize];
	if(img)
	{
		delete img;
		img = NULL;
	}
	if(total_frame_nr >= 1)
	{
		img = new QImage(sizeX, sizeY, QImage::Format_RGB32);
		showFirstFrame();
	}
	else
	{
		delete yuvbuf;
		yuvbuf = NULL;
		cur_frame_nr = 0;
	}
	return total_frame_nr;
}

/*shows first image*/
void Seqdis::showFirstFrame()
{
	cur_frame_nr = 1;
	showCurrentFrame();
	if(YBlock->isVisible())
		YBlock->close();
}

void Seqdis::showNextFrame()
{
	if(cur_frame_nr < total_frame_nr)
	{
		++cur_frame_nr;
		showCurrentFrame();
		if(YBlock->isVisible())
			YBlock->close();
	}
}

void Seqdis::showPreviousFrame()
{
	if(cur_frame_nr > 1)
	{
		--cur_frame_nr;
		showCurrentFrame();
		if(YBlock->isVisible())
			YBlock->close();
	}
}

void Seqdis::showFrameNr(int fr_nr)
{
	if(fr_nr>=1 && fr_nr <= total_frame_nr)
	{
		cur_frame_nr = fr_nr;
		showCurrentFrame();
		if(YBlock->isVisible())
			YBlock->close();
	}
}

void Seqdis::showCurrentFrame()
{
	QPainter p;
	if(total_frame_nr >0)
	{	
		file.seek ((cur_frame_nr-1)*yuvbuffersize);
		convertFrame();
	}
	else
		cur_frame_nr = 0;
	this->repaint();
}

int Seqdis::getCurrentFrameNr() const
{
	return cur_frame_nr;
}

void Seqdis::paintEvent(QPaintEvent *)
{
	QPainter p;
	p.begin(this);
	if(img)
		p.drawImage(0,0,*img);
	p.end();
}

void Seqdis::closeEvent(QCloseEvent * event )
{
	parent->sequenceClosed();
	YBlock->close();
	event->accept();
}

void Seqdis::mouseReleaseEvent(QMouseEvent * event )
{
	int imin, jmin, imax, jmax, i, j;
	
	if(cur_frame_nr <1 || event->button()==Qt::RightButton || parent->isPlaying())
		return;
	this->showCurrentFrame();
	QPoint p = event->pos();
	imin = p.x()-5>=0 ? p.x()-5 : 0;
	jmin = p.y()-5>=0 ? p.y()-5 : 0;
	imax = p.x()+5<sizeX ? p.x()+5 : sizeX-1;
	jmax = p.y()+5<sizeY ? p.y()+5 : sizeY-1;
	for(i = imin; i <= imax; i++)
	{
		img->setPixel(i, jmin, 4294967295);
		img->setPixel(i, jmax, 4294967295);
	}
	for(j=jmin; j<= jmax; j++ )
	{
		img->setPixel(imin,j, 4294967295);
		img->setPixel(imax,j, 4294967295);
	}
	this->update();
	YBlock->setTable(yuvbuf, p.x(), p.y(),sizeX, sizeY, par);
	YBlock->setWindowState(YBlock->windowState() & ~Qt::WindowMinimized | Qt::WindowActive);
	if(YBlock->isVisible())
	{
		YBlock->update();
	}
	else
		YBlock->showNormal();
	YBlock->raise();
}

void Seqdis::convertFrame()
{
	int u_offset, v_offset;
	rgbbuf = img->bits();		// set the rgb-pointer to the QImage to be shown
	if(format == _420)
	{
		u_offset = sizeX*sizeY;
		v_offset = u_offset+u_offset/4;
	}
	else if(format == _400)
	{
		u_offset = 0;
		v_offset = 0;
	}
	else if(format == _422)
	{
		u_offset = sizeX*sizeY;
		v_offset = u_offset+u_offset/2;
	}
	else // format == _444
	{
		u_offset = sizeX*sizeY;
		v_offset = 2*u_offset;
	}

	file.read((char*)yuvbuf, yuvbuffersize);
	uchar *pY = yuvbuf;
	uchar *pU = yuvbuf + u_offset;
	uchar *pV = yuvbuf + v_offset;
	if(format == _420)
	{
		yuv2rgb_420( rgbbuf, pY, pU, pV, sizeX, sizeY);
/*
		for( int y = 0; y < sizeY; y+=2 )
		{
			for( int x = 0; x < sizeX; x+=2 )
			{
				U = *pU++ - 128.0;
				V = *pV++ - 128.0;
				Y = pY[0];
				YUV2RGB;
				*rgbbuf++ = B;
				*rgbbuf++ = G;
				*rgbbuf++ = R;
				*rgbbuf++ = 255; // aplha

				Y = pY[1];
				YUV2RGB;
				*rgbbuf++ = B;
				*rgbbuf++ = G;
				*rgbbuf++ = R;
				*rgbbuf++ = 255; // aplha

				rgbbuf += 4*(sizeX-2);

				Y = pY[sizeX];
				YUV2RGB;
				*rgbbuf++ = B;
				*rgbbuf++ = G;
				*rgbbuf++ = R;
				*rgbbuf++ = 255; // aplha

				Y = pY[sizeX+1];
				YUV2RGB;
				*rgbbuf++ = B;
				*rgbbuf++ = G;
				*rgbbuf++ = R;
				*rgbbuf++ = 255; // aplha

				rgbbuf -= 4*sizeX;
				pY += 2;
			}
			pY += sizeX;
			rgbbuf += 4*sizeX;
		}
*/
	}
	else if(format == _400)
	{
		yuv2rgb_400( rgbbuf, pY, sizeX, sizeY);
/*
		for( int y = 0; y < sizeY; ++y )
		{
			for( int x = 0; x < sizeX; ++x )
			{
				Y = *pY++;
				R=B=G=(int)(Y);
				*rgbbuf++ = B;
				*rgbbuf++ = G;
				*rgbbuf++ = R;
				*rgbbuf++ = 255; // aplha
			}
		}
*/
	}
	else if(format == _422)
	{
		yuv2rgb_422( rgbbuf, pY, pU, pV, sizeX, sizeY);
/*
		for( int y = 0; y < sizeY; ++y )
		{
			for( int x = 0; x < sizeX; x+=2 )
			{
				U = *pU++ - 128.0;
				V = *pV++ - 128.0;
				Y = *pY++;
				YUV2RGB;
				*rgbbuf++ = B;
				*rgbbuf++ = G;
				*rgbbuf++ = R;
				*rgbbuf++ = 255; // aplha

				Y = *pY++;
				YUV2RGB;
				*rgbbuf++ = B;
				*rgbbuf++ = G;
				*rgbbuf++ = R;
				*rgbbuf++ = 255; // aplha
			}
		}
*/
	}

	else // format = _444
	{
		yuv2rgb_444( rgbbuf, pY, pU, pV, sizeX, sizeY);
/*
		for( int y = 0; y < sizeY; ++y )
		{
			for( int x = 0; x < sizeX; ++x )
			{
				Y = *pY++;
				U = *pU++ -128.0;
				V = *pV++ -128.0;
				YUV2RGB;
				*rgbbuf++ = B;
				*rgbbuf++ = G;
				*rgbbuf++ = R;
				*rgbbuf++ = 255; // aplha
			}
		}
*/
	}
}

QImage Seqdis::getImage() const
{
	return *img;
}


//========================== TableYValues =========================================
TableYValues::TableYValues(QWidget * parent, Qt::WFlags f) : QWidget(parent, f)
{
	this->setFixedSize ( 300, 180 );
	QFont font("Helvetica", 10, QFont::Normal);
	font.setPixelSize(10);
	this->setFont(font);
//	this->setWindowFlags(Qt::WindowShadeButtonHint);
	this->itemSizeX = 30;
	this->itemSizeY = 18;
	this->parent = (Seqdis*)(parent);
	WhiteColorButton = new QPushButton(this);
	WhiteColorButton->setGeometry(0,0,this->itemSizeX,this->itemSizeY);
	WhiteColorButton->setText("ToG");
	WhiteColorButton->setToolTip("Change to grey value background");
	curWhiteColorState=false;
	connect(WhiteColorButton, SIGNAL(clicked()), this, SLOT(changeWhite_Color()));
}

void TableYValues::setTable(uchar *pY, int posX, int posY, int imgWidth, int imgHeight, int curWindow)
{
	int i,j;
	int curPtrX, curPtrY;
	
	for(i=0;i<9;i++)
		for(j=0;j<9; j++)
		{
//			QTableWidgetItem *newItem = new QTableWidgetItem(tr("%1").arg((row+1)*(column+1)));
			curPtrX = (posX-4+i);
			curPtrY = (posY-4+j);
			if(curPtrX < 0 || curPtrX >= imgWidth || curPtrY < 0 || curPtrY >= imgHeight)
					curValues[i+1][j+1] = -100;
			else
				curValues[i+1][j+1] = pY[curPtrY*imgWidth+curPtrX];
		}
	for(i=0;i<9; i++)
	{
		curValues[i+1][0] = posX-4+i;
		curValues[0][i+1] = posY-4+i;
	}
	if(curWindow == 1)
		this->setWindowTitle("Info Window 1");
	else
		this->setWindowTitle("Info Window 2");
}

void TableYValues::paintEvent(QPaintEvent *)
{
	QPainter painter;
	QBrush brush;
	QPen pen;
	QColor color1, color2;
	int i, j;
	QString string1, string2;
	
	QLineF line1(float(this->itemSizeX),float(this->itemSizeY+1),float(this->itemSizeX),this->height());
	QLineF line2(float(this->itemSizeX),float(this->itemSizeY+1),this->width(),float(this->itemSizeY+1));
	painter.begin(this);
	color1.setRgb(0,0,255);
	painter.setPen(color1);
	painter.drawLine(line1);
	painter.drawLine(line2);
	for(i = 0; i < 10; i++)
		for(j = 0; j < 10; j++)
		{
			if(!i && !j)
				j++;			
			if(i>0 && j>0 && curWhiteColorState)
			{
				if(curValues[i][j]>=0 && curValues[i][j]<256)
				{
					color2.setRgb(curValues[i][j],curValues[i][j],curValues[i][j]);
					if(curValues[i][j]>=0 && curValues[i][j]<128)
						color1.setRgb(255,255,255);
					else
						color1.setRgb(  0,  0,  0);
				}
				else
				{
					color1.setRgb(0,0,0);
					color2.setRgb(255,255,255);
				}
				brush.setColor(color2);
				brush.setStyle(Qt::SolidPattern);
			}
			else
			{
				brush.setStyle(Qt::NoBrush);
				if(i==5 && j==5)
					color1.setRgb(255,0,0);
				else 
					color1.setRgb(0,0,0);
			}
			pen.setColor(color1);

			painter.setPen(pen);
			if(curValues[i][j] == -100)
				string1 = "  - ";
			else if(curValues[i][j] < 0)
			{
				string1 = "  ";
				string2.setNum(curValues[i][j]);
				string1.append(string2);
			}
			
			else if(curValues[i][j] < 10)
			{
				string1 = "   ";
				string2.setNum(curValues[i][j]);
				string1.append(string2);
			}
			else if(curValues[i][j] < 100)
			{
				string1 = "  ";
				string2.setNum(curValues[i][j]);
				string1.append(string2);
			}
			else if(curValues[i][j] < 1000)
			{
				string1 = " ";
				string2.setNum(curValues[i][j]);
				string1.append(string2);			
			}
			else
				string1.setNum(curValues[i][j]);
			painter.fillRect(i*itemSizeX,j*itemSizeY, itemSizeX, itemSizeY, brush);
			painter.drawText(i*itemSizeX+1, (j+1)*itemSizeY-1, string1);
		}
	painter.end();
}

void TableYValues::closeEvent(QCloseEvent * e)
{
	parent->showCurrentFrame();
	e->accept();
}

//-----------------------slots implementation---------------------

void TableYValues::changeWhite_Color()
{

	if(curWhiteColorState)
	{
		curWhiteColorState = false;
		WhiteColorButton->setText("ToG");
		WhiteColorButton->setToolTip("Change to grey value background");
	}
	else
	{
		curWhiteColorState = true;
		WhiteColorButton->setText("ToW");
		WhiteColorButton->setToolTip("Change to white background");
	}
	this->update();

}


Difference::Difference(QWidget *p, Qt::WFlags flags): QWidget(p, flags)
{
	sizeX = CIF_X;
	sizeY = CIF_Y;
	yuv1 = yuv2 = NULL;
	this->initLogTable();
	img = NULL;
	parent=(MainWindow*)(p);
}

void Difference::setSizeXY(int sX, int sY)
{
	sizeX = sX;
	sizeY = sY;
	this->setFixedSize(sizeX, sizeY);
	if(this->isVisible())
		this->update();
}

void Difference::setFramesPointer(uchar *y1, uchar *y2)
{
	yuv1=y1;
	yuv2=y2;
	if(img)
	{
		delete img;
		img = NULL;
	}
	img = new QImage(sizeX, sizeY, QImage::Format_RGB32);
	rgbbuf = img->bits();
}

void Difference::initLogTable()
{
	int i;
	for(i=0; i <= 256; i++)
		logNat_table[i] = log((double)i);
}

void Difference::showDifference(int log)
{
	double PSNR=0.0, Yd;
	double MSE = 0.0;
	int Y1, Y2, Y, R, G, B;
	QString string = "F1-F2:";
	QString s;

	for( int y = 0; y < sizeY; ++y ) 
	{
		for( int x = 0; x < sizeX; ++x ) 
		{
			Y1 = *yuv1++;
			Y2 = *yuv2++;
			MSE += (Y1-Y2)*(Y1-Y2);
			if(log)
			{
				Yd = 127.0 + 128.0*logNat_table[1+abs(Y1-Y2)]/logNat_table[256]*(Y1>Y2?1:-1);
				Y = (int)(Yd+0.5);			
			}
			else
				Y = (Y1-Y2+255)/2;
			if(Y<0)
				Y = 0;
			if(Y>255)
				Y = 255;
			R=B=G=Y;
			*rgbbuf++ = B;
			*rgbbuf++ = G;
			*rgbbuf++ = R;
			*rgbbuf++ = 255; // aplha
		}
	}
	if(MSE==0.0)
		PSNR = 0.0;
	else
		PSNR= 10.0 * log10(sizeX*sizeY * 255.0 * 255.0 / MSE);

	if(PSNR == 0.0)
		s="oo";
	else
		s.setNum(PSNR,'g',5);
	string.append(s);
	string.append(" dB (PSNR)");
	this->setWindowTitle(string);
	if(this->isVisible())
		this->update();
	else
		this->show();
}

void Difference::paintEvent(QPaintEvent *)
{
	QPainter p;
	p.begin(this);
	if(img)
		p.drawImage(0,0,*img);
	p.end();
}

void Difference::closeEvent(QCloseEvent * e )
{
	parent->diffClosed();
	e->accept();
}

void Difference::mouseReleaseEvent(QMouseEvent *event)
{
	QPoint p = event->pos();
	if(event->button()==Qt::RightButton)
		return;
	parent->showYBlocks(event);
}

QImage Difference::getImage() const
{
	return *img;
}
