/***************************************************************************
 *   Copyright (C) 2005 by Yuri Vatis   																	 *
 *   vatis@tnt.uni-hannover.de																						 *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include <iostream>
#include <stdio.h>
//#include <stdlib.h>
#include <math.h>
#include <QApplication>
#include <QFile>
#include "controlbar.h"
#include "mainwindow.h"
#include "global.h"
#include <QFileDialog>

using namespace std;

int main(int argc, char *argv[])
{
	int cur_argc;
	bool freqset, file1set, file2set, loopset, diffset, playset, sizeset, formatset;
	int sX = CIF_X, sY=CIF_Y, difftype = -1, formattype = 1, frequency = 30;
	QString file1Name, file2Name;
	QFile file;
	freqset=file1set=file2set=loopset=diffset=playset=sizeset=formatset=false;
	QApplication app( argc, argv );
	MainWindow *test = new MainWindow(0);
	test->show();
	if(argc > 1)
	{
		for(cur_argc = 1; cur_argc < argc; cur_argc++)
		{
			if(0 == strncmp (argv[cur_argc], "-d", 2))				// setting difference type
			{
				if(diffset)
				{
					cout<<"parameter \"d\" already set!\n";
					exit(-1);
				}
				diffset = true;
				cur_argc++;
				if(cur_argc >= argc)
				{
					cout<<"difference type not set!\n";
					exit(-1);
				}
				if((0 == strncmp (argv[cur_argc], "0", 1) ||
						0 == strncmp (argv[cur_argc], "1", 1) ) &&
						strlen(argv[cur_argc])==1)
					difftype = atoi(argv[cur_argc]);
				else
				{
					cout<<"difference type not set!\n";
					exit(-1);
				}
			}
			else if(0 == strncmp (argv[cur_argc], "-s", 2))		// setting difference type
			{
				if(sizeset)
				{	
					cout<<"parameter \"s\" already set!\n";
					exit(-1);
				}
				sizeset = true;
				cur_argc++;
				if(cur_argc >= argc)
				{
					cout<<"size not set!\n";
					exit(-1);
				}
				if(0 == strncmp (argv[cur_argc], "qcif", 4) && strlen(argv[cur_argc]) == 4)
				{
					sX = QCIF_X;
					sY = QCIF_Y;
				}
				else if(0 == strncmp (argv[cur_argc], "cif", 3) && strlen(argv[cur_argc]) == 3)
				{
					sX = CIF_X;
					sY = CIF_Y;
				}
				else if(0 == strncmp (argv[cur_argc], "vga", 3) && strlen(argv[cur_argc]) == 3)
				{
					sX = VGA_X;
					sY = VGA_Y;
				}
				else if(0 == strncmp (argv[cur_argc], "sdtv", 4) && strlen(argv[cur_argc]) == 4)
				{
					sX = SDTV_X;
					sY = SDTV_Y;
				}
				else if(0 == strncmp (argv[cur_argc], "720p", 4) && strlen(argv[cur_argc]) == 4)
				{
					sX = HDTV_X;
					sY = HDTV_Y;
				}
        else if(0 == strncmp (argv[cur_argc], "1080p", 5) && strlen(argv[cur_argc]) == 5)
        {
          sX = SHDTV_X;
          sY = SHDTV_Y;
        }
				else
				{
					sX = atoi(argv[cur_argc]);
					cur_argc++;
					if(cur_argc>=argc)
					{
						cout<<"size not set!\n";
						exit(-1);
					}
					sY = atoi(argv[cur_argc]);
				}
				if(sX < 16 || sY < 16 || sX > 4000 || sY > 4000)
				{
					cout<<"x-values [16; 4000] and y-values [16;4000] are allowed only!\n";
          printf("%d, %d\n",sX, sY);
					exit(-1);
				}
			}
			else if(0 == strncmp (argv[cur_argc], "-p", 2))		// setting play
			{
				if(strlen(argv[cur_argc])> 2)
				{
					cout<<"unknown parameter: "<<argv[cur_argc]<<"\n";
					exit(-1);				
				}
				if(playset)
				{	
					cout<<"parameter \"p\" already set!\n";
					exit(-1);
				}
				playset = true;
			}
			else if(0 == strncmp (argv[cur_argc], "-f", 2))		// setting frequency
			{
				if(strlen(argv[cur_argc])> 2)
				{
					cout<<"unknown parameter: "<<argv[cur_argc]<<"\n";
					exit(-1);				
				}

				if(freqset)
				{
					cout<<"parameter \"f\" already set!\n";
					exit(-1);
				}
				freqset = true;
				cur_argc++;
				if(cur_argc >= argc)
				{
					cout<<"frequency not set!\n";
					exit(-1);
				}
				frequency = atoi(argv[cur_argc]);
				if(frequency < 1 || frequency > 60)
				{
					cout<<"frequency not set([1; 60]) !\n";
					exit(-1);
				}
			}
			else if(0 == strncmp (argv[cur_argc], "-y", 2))		// setting format
			{
				if(formatset)
				{
					cout<<"parameter \"y\" already set!\n";
					exit(-1);
				}
				if(strlen(argv[cur_argc])> 2)
				{
					cout<<"unknown parameter: "<<argv[cur_argc]<<"\n";
					exit(-1);				
				}
				formatset = true;
				cur_argc++;
				if(cur_argc >= argc)
				{
					cout<<"yuv-format not set!\n";
					exit(-1);
				}
				if((0 == strncmp (argv[cur_argc], "0", 1) ||
						0 == strncmp (argv[cur_argc], "1", 1) ||
					 	0 == strncmp (argv[cur_argc], "2", 1) ||
					 	0 == strncmp (argv[cur_argc], "3", 1) ) &&
						strlen(argv[cur_argc])==1)
					formattype = atoi(argv[cur_argc]);
				else
				{
					cout<<"wrong yuv-format!\n";
					exit(-1);					
				}
			}
			else if(0 == strncmp (argv[cur_argc], "-l", 2))		// setting loop
			{
				if(strlen(argv[cur_argc])> 2)
				{
					cout<<"unknown parameter: "<<argv[cur_argc]<<"\n";
					exit(-1);				
				}

				if(loopset)
				{
					cout<<"parameter \"l\" already set!\n";
					exit(-1);
				}
				loopset = true;				
			}
			else if(0 == strncmp (argv[cur_argc], "-h", 2))			// help
			{
				if(strlen(argv[cur_argc])> 2)
				{
					cout<<"unknown parameter: "<<argv[cur_argc]<<"\n";
					exit(-1);				
				}
				cout<<"yuvplayer [-h] [-d type] [-s [sizeX sizeY]|[size] (cif)] [-l] [-y(420)] [-f freq(30)] [-p] fileName1 [fileName2]"<<endl;
				cout<<"-h                                              : Print this help"<<endl;
				cout<<"-d 0|1                                          : Show difference window, 0 - linear, 1 - logarithmic"<<endl;
				cout<<"-s [sizeX sizeY]|[qcif|cif|vga|sdtv|720p|1080p] : Width, Height "<<endl;
				cout<<"-l                                              : Loop"<<endl;
				cout<<"-y 0|1|2|3                                      : 400|420|422|444"<<endl;
				cout<<"-f 1|2|5|10|15|20|25|30|50|60                   : Frequency"<<endl;
				cout<<"-p                                              : Play"<<endl;
				exit(-1);
			}
			else
			{
				if(0 == strncmp(argv[cur_argc], "-", 1))
				{
					cout<<"undefined parameter\n";
					exit(-1);
				}
				if(!file1set)
				{
					file1set = true;
					file1Name = argv[cur_argc];
					if(!file.exists(file1Name))
					{
						cout<<"cannot open file1\n";
						exit(-1);
					}
					cur_argc++;
					if(cur_argc<argc)
					{
						file2set = true;
						file2Name = argv[cur_argc];
						if(!file.exists(file2Name))
						{
							cout<<"cannot open file2\n";
							exit(-1);
						}
					}
					if(!file2set && diffset)
					{
						cout<<"-d parameter cannot be set if only 1 file is open\n";
						exit(-1);
					}
				}
				else
				{
					cout<<"last parameter unknown\n";
					exit(-1);
				}
			}
		}
		test->init(sX, sY, loopset, playset, difftype, formattype, frequency, file1Name, file2Name);
	}
	return app.exec();
}
